> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://contentful.com/developers/docs/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://contentful.com/developers/docs/_mcp/server.

# Create a content type with POST

POST https://api.contentful.com/spaces/{space_id}/environments/{environment_id}/content_types
Content-Type: application/vnd.contentful.management.v1+json

Creates a content type with an auto-generated ID. Prefer the PUT method to control the content type ID, since IDs are often referenced in code.

Reference: https://contentful.com/developers/docs/references/content-management-api/content-types/create-a-content-type-with-post

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `space_id` (string, required) — ID of the Space in form of a string
- `environment_id` (string, required) — ID of the environment in form of a string

### Body (application/vnd.contentful.management.v1+json)

This endpoint expects a map from string to any.

- `map from string to any`

## Response

### 201

Created - Resource created successfully

- `map from string to any`

## Examples

**Request**

```json
{
  "fields": [
    {
      "id": "title",
      "localized": true,
      "name": "Title",
      "required": true,
      "type": "Text"
    },
    {
      "id": "body",
      "localized": true,
      "name": "Body",
      "required": true,
      "type": "Text"
    }
  ],
  "name": "Blog Post"
}
```

**Response**

```json
{
  "sys": {
    "createdAt": "2025-03-08T12:41:45.000Z",
    "createdBy": {
      "sys": {
        "id": "7BslKh9TdKGOK41VmLDjFZ",
        "linkType": "User",
        "type": "Link"
      }
    },
    "environment": {
      "sys": {
        "id": "staging",
        "linkType": "Environment",
        "type": "Link"
      }
    },
    "id": "3ORKIAOaJqQWWg86MWkyOs",
    "space": {
      "sys": {
        "id": "yadj1kx9rmg0",
        "linkType": "Space",
        "type": "Link"
      }
    },
    "type": "ContentType",
    "updatedAt": "2025-03-08T12:41:45.000Z",
    "updatedBy": {
      "sys": {
        "id": "4FLrUHftHW3v2BLi9fzfjU",
        "linkType": "User",
        "type": "Link"
      }
    },
    "version": 1
  }
}
```

**SDK Code**

```android Android
// Create the Contentful client.
final CMAClient client =
    new CMAClient
        .Builder()
        .setAccessToken("<access_token>")
        .setSpaceId("<space_id>")
        .setEnvironmentId("<environment_id>")
        .build();

// Create a local content type.
final CMAContentType contentType =
    new CMAContentType()
        .setDescription("My new content type");

// Now publish it to activate it.
client
    .contentTypes()
    .async()
    .publish(
        contentType,
        new CMACallback<CMAContentType>() {
          @Override protected void onSuccess(CMAContentType result) {
            // Created.
            new AlertDialog.Builder(context)
                .setTitle("Contentful")
                .setMessage("Creatino of a content type was successful." +
                    "\n\nResult: " + result)
                .show();
          }

          @Override protected void onFailure(RuntimeException exception) {
            // An error occurred! Inform the user.
            new AlertDialog.Builder(context)
                .setTitle("Contentful Error")
                .setMessage("Could not create a content type." +
                    "\n\nReason: " + exception.toString())
                .show();

            super.onFailure(exception);
          }
        }
    );
```

```java Java
// Create the Contentful client.
final CMAClient client =
    new CMAClient
        .Builder()
        .setAccessToken("<access_token>")
        .setSpaceId("<space_id>")
        .setEnvironmentId("<environment_id>")
        .build();

// Create a local content type.
final CMAContentType contentType =
    new CMAContentType()
        .setId("snippet_content_type")
        .setName("Some name for the content type.")
        .setDescription("My new content type");

// Now publish it to activate it.
final CMAContentType published = client
    .contentTypes()
    .create(contentType);
```

```kotlin Kotlin
// Create the Contentful client.
val client = CMAClient.Builder()
    .setAccessToken("<access_token>")
    .setSpaceId("<space_id>")
    .setEnvironmentId("<environment_id>")
    .build()

// Create a local content type.
val contentType = CMAContentType()
        .setId("snippet_content_type")
        .setName("Some name for the content type.")
        .setDescription("My new content type")

// Now publish it to activate it.
val published = client
        .contentTypes()
        .create(contentType)
```

```swift Swift
We currently don't provide a CMA SDK for this platform.
```

```js-legacy JavaScript (legacy)
import { createClient } from 'contentful-management'

const client = createClient({
  accessToken: '<content_management_api_key>'
}, { type: 'legacy' })

client.getSpace('<space_id>')
.then((space) => space.getEnvironment('<environment_id>'))
.then((environment) => environment.createContentType({
  name: 'Blog Post',
  fields: [
    {
      id: 'title',
      name: 'Title',
      required: true,
      localized: false,
      type: 'Text'
    }
  ]
}))
.then((contentType) => console.log(contentType))
.catch(console.error)
```

```javascript JavaScript
import { createClient } from 'contentful-management'

// Client init
const client = createClient({
  accessToken: '<content_management_api_key>'
})

await client.contentType.create(
  {
    spaceId: '<space_id>',
    environmentId: '<environment_id>',
  },
  {
    name: 'Blog Post',
    fields: [
      {
        id: 'title',
        name: 'Title',
        required: true,
        localized: false,
        type: 'Text'
      }
    ]
  });
```

```php PHP
$client = new \Contentful\Management\Client('<content_management_api_key>');

$environment = $client->getEnvironmentProxy('<space_id>', '<environment_id>');

$contentType = new \Contentful\Management\Resource\ContentType('New Content Type');
$contentType->setDescription('Content type description')
    ->setDisplayField('name')
    ->addNewField('Symbol', 'name', 'Name');

$environment->create($contentType, 'newContentType');
```

```ruby Ruby
require 'contentful/management'

client = Contentful::Management::Client.new('<content_management_api_key>')

field = Contentful::Management::Field.new
field.id = 'name'
field.name = 'Name'
field.type = 'Symbol'
content_type = client.content_types('<space_id>', '<environment_id>').create(
  id: 'newContentType',
  name: 'New Content Type',
  description: 'Content type description',
  displayField: 'name',
  fields: [field]
)
```

```python Python
from contentful_management import Client

client = Client('<content_management_api_key>')

content_type_id = '<content_type_id>'  # Use `None` if you want the API to autogenerate the ID.
content_type = client.content_types('<space_id>', '<environment_id>').create(content_type_id, {
    'name': 'New Content Type',
    'description': 'Content Type Description',
    'displayField': 'name',
    'fields': [
        {
            'name': 'Name',
            'id': 'name',
            'type': 'Symbol',
            'localized': False
        }
    ]
})
```

```.net .NET
// This client should only be created once per application.
var httpClient = new HttpClient();

var client = new ContentfulManagementClient(httpClient, "<content_management_api_key>", "<space_id>");

var contentType = new ContentType();
contentType.SystemProperties = new SystemProperties();
contentType.SystemProperties.Id = "<content_type_id>";
contentType.Name = "New content type";
contentType.Description = "Content type description";

contentType.Fields = new List<Field>()
{
    new Field()
    {
        Name = "Field name",
        Id = "fieldName",
        Type = "Text",
        Required = true,
        Localized = false,
        Disabled = false,
        Omitted = false,
    }
};

contentType.DisplayField = "fieldName";

await _client.CreateOrUpdateContentType(contentType);
```